/**
 * @license angular-library-starter
 * MIT license
 */

import { Component, EventEmitter, Injectable, NgModule } from '@angular/core';
import { Observable as Observable$1 } from 'rxjs/Observable';
import 'rxjs/add/operator/map';
import { Http, Response, ResponseContentType } from '@angular/http';
import 'rxjs/Rx';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import 'rxjs/add/operator/do';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class AuthGuard {
    constructor() { }
    /**
     * @param {?} route
     * @param {?} state
     * @return {?}
     */
    canActivate(route, state) {
        if (AuthGuard.hasAccess.indexOf(route.data['nome']) != -1) {
            return true;
        }
        else {
            return false;
        }
    }
}
AuthGuard.hasAccess = new Array();
AuthGuard.decorators = [
    { type: Injectable },
];
/** @nocollapse */
AuthGuard.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class CookieService {
    constructor() {
    }
    /**
     * @param {?} name
     * @return {?}
     */
    getCookie(name) {
        let /** @type {?} */ ca = document.cookie.split(';');
        let /** @type {?} */ caLen = ca.length;
        let /** @type {?} */ cookieName = name + "=";
        let /** @type {?} */ c;
        for (let /** @type {?} */ i = 0; i < caLen; i += 1) {
            c = ca[i].replace(/^\s\+/g, "");
            if (c.indexOf(cookieName) == 0) {
                return c.substring(cookieName.length, c.length);
            }
        }
        return "";
    }
    /**
     * @param {?} name
     * @param {?} value
     * @param {?} expireMilisecounds
     * @param {?} path
     * @param {?} domain
     * @param {?} secure
     * @return {?}
     */
    setCookie(name, value, expireMilisecounds, path, domain, secure) {
        let /** @type {?} */ d = new Date();
        d.setTime(d.getTime() + expireMilisecounds);
        let /** @type {?} */ expires = d.toUTCString();
        let /** @type {?} */ cookirFormatado = name + "=" + value + ";" +
            ((path) ? " path=" + path + ";" : "") +
            ((domain) ? " domain=" + domain + "" : "");
        document.cookie = cookirFormatado;
    }
}
CookieService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
CookieService.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class ServiceUtil {
    /**
     * @param {?} res
     * @return {?}
     */
    extractData(res) {
        let /** @type {?} */ body = res.json();
        return body.data || {};
    }
    /**
     * @param {?} error
     * @return {?}
     */
    handleError(error) {
        let /** @type {?} */ errMsg;
        if (error instanceof Response) {
            const /** @type {?} */ body = error.json() || '';
            const /** @type {?} */ err = body.message || JSON.stringify(body);
            errMsg = err;
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        if (errMsg == "{\"isTrusted\":true}") {
            errMsg = "Servidor de Dados Indisponível Temporariamente.";
        }
        else if (errMsg == "{\"error\":\"eunavailable_service\"}") {
            errMsg = "Servidor de Dados Indisponível Temporariamente.";
        }
        else if (errMsg == "{\"error\": \"enoent_service_contract\"}") {
            return new Observable$1();
        }
        else if (errMsg == "{\"error\": \"einvalid_request\"}") {
            errMsg = "Requisição inválida.";
        }
        else if (errMsg == "{\"error\": \"etimeout_service\"}") {
            errMsg = "Servidor de Dados Indisponível Temporariamente.";
        }
        else if (errMsg == "{\"error\": \"access_denied\"}") {
            return new Observable$1();
        }
        else {
            return Observable$1.throw(error);
        }
        return Observable$1.throw(errMsg);
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class RedirectService {
    /**
     * @param {?} authenticationService
     * @param {?} cookieService
     */
    constructor(authenticationService, cookieService) {
        this.authenticationService = authenticationService;
        this.cookieService = cookieService;
        this.localDateTime = 0;
        this.auth_url = '';
        this.result = '';
        this._aplicacaoInativa = 'inativatedApplication';
        this._rotaAtual = 'erlangms_actualRoute_';
        RedirectService.instanceAuthenticationService = this.authenticationService;
    }
    /**
     * @return {?}
     */
    static getInstance() {
        return RedirectService.instanceAuthenticationService;
    }
    /**
     * @param {?} baseUrl
     * @return {?}
     */
    startRedirectFromBarramento(baseUrl) {
        let /** @type {?} */ urlName = window.location.href.split('/');
        this.authenticationService.base_url = baseUrl;
        return Observable$1.create((observer) => {
            this.authenticationService.getUrl()
                .subscribe((result) => {
                this.auth_url = result.url;
                if (this.authenticationService.currentUser.client_id <= 0) {
                    this.authenticationService.getClientCode(urlName[3])
                        .subscribe((res) => {
                        if (this.authenticationService.activatedSystem) {
                            this.startInitVerifySessionToken()
                                .subscribe((resp) => {
                                return observer;
                            }, (error) => {
                                console.log(error);
                            });
                        }
                        else {
                            localStorage.removeItem(urlName[3]);
                            localStorage.removeItem(this._rotaAtual + '' + urlName[3]);
                            var /** @type {?} */ myVal = document.getElementById(this._aplicacaoInativa);
                            if (myVal != null) {
                                myVal.innerHTML = `
                                    <h2>Sistema temporariamente indisponível.</h2>
                                    `;
                            }
                        }
                    }, (error) => {
                        console.log(error);
                    });
                }
                else {
                    this.startInitVerifySessionToken()
                        .subscribe((resp) => {
                        return observer;
                    }, (error) => {
                        console.log(error);
                    });
                }
            }, (error) => {
                console.log(error);
            });
        });
    }
    /**
     * @return {?}
     */
    startInitVerifySessionToken() {
        if (this.authenticationService.currentUser.token && this.authenticationService.currentUser.timer) {
            let /** @type {?} */ timeAccess = Date.now();
            let /** @type {?} */ total = timeAccess - Number(this.authenticationService.currentUser.timer);
            if (this.authenticationService.currentUser.expires_in != '') {
                if (total > this.authenticationService.currentUser.expires_in * 1000) {
                    this.authenticationService.reset();
                    return Observable$1.create((observer) => {
                        return observer;
                    });
                }
                else {
                    let /** @type {?} */ urlName = window.location.href.split('/');
                    this.authenticationService.periodicIncrement(this.authenticationService.currentUser.expires_in);
                    return Observable$1.create((observer) => {
                        return observer;
                    });
                }
            }
        }
        if (this.authenticationService.currentUser.token && this.authenticationService.currentUser.token != "") {
            return Observable$1.create((observer) => {
                this.verifyTimeTokenExpired()
                    .subscribe((resposta) => {
                    return observer;
                });
            });
        }
        var /** @type {?} */ code = window.location.href.split('code=')[1];
        if (code == undefined) {
            if (this.authenticationService.currentUser.token == '') {
                return Observable$1.create((observer) => {
                    this.initVerificationRedirect()
                        .subscribe((resp) => {
                        return observer;
                    });
                });
            }
            else {
                return Observable$1.create((observer) => {
                    this.authenticationService.periodicIncrement(this.authenticationService.currentUser.expires_in)
                        .subscribe((resp) => {
                        return observer;
                    });
                });
            }
        }
        else if (this.authenticationService.currentUser.token == '' && code != undefined) {
            return Observable$1.create((observer) => {
                this.redirectWithCodeUrl(code)
                    .subscribe((resp) => {
                    return observer;
                });
            });
        }
        return Observable$1.create((observer) => {
            return observer;
        });
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
    }
    /**
     * @return {?}
     */
    verifyTimeTokenExpired() {
        let /** @type {?} */ dateSecoundAccess = Date.now();
        this.localDateTime = Number(this.authenticationService.currentUser.timer);
        let /** @type {?} */ value = dateSecoundAccess - this.localDateTime;
        if (value >= (this.authenticationService.currentUser.expires_in * 1000)) {
            this.authenticationService.logout();
        }
        return Observable$1.create((observer) => {
            return observer;
        });
    }
    /**
     * @return {?}
     */
    initVerificationRedirect() {
        if (this.authenticationService.currentUser.timer && this.authenticationService.currentUser.token != "") {
            return Observable$1.create((observer) => {
                this.verifyTimeTokenExpired()
                    .subscribe((resp) => {
                    return observer;
                });
            });
        }
        else {
            if (this.authenticationService.currentUser.token != '') {
                return Observable$1.create((observer) => {
                    this.authenticationService.periodicIncrement(this.authenticationService.currentUser.expires_in)
                        .subscribe((resp) => {
                        return observer;
                    });
                });
            }
            else {
                return Observable$1.create((observer) => {
                    this.authenticateClient()
                        .subscribe((resp) => {
                        return observer;
                    });
                });
            }
        }
    }
    /**
     * @param {?} code
     * @return {?}
     */
    redirectWithCodeUrl(code) {
        let /** @type {?} */ url_client = window.location.href;
        let /** @type {?} */ array = url_client.split('/');
        let /** @type {?} */ nomeSistema = array[3].split('#');
        let /** @type {?} */ base_auth = this.auth_url.split('?');
        return Observable$1.create((observer) => {
            this.authenticationService.redirectUserTokenAccess(base_auth[0], this.authenticationService.currentUser.client_id, this.authenticationService.clientSecret, code, 'authorization_code', '/' + nomeSistema[0] + '/index.html/')
                .subscribe((resposta) => {
                return observer;
            });
        });
    }
    /**
     * @return {?}
     */
    authenticateClient() {
        if (!this.authenticationService.currentUser.token) {
            this.authenticationService.reset();
            let /** @type {?} */ urlName = window.location.href.split('/');
            return Observable$1.create((observer) => {
                let /** @type {?} */ parts = this.auth_url.split('client_id=');
                let /** @type {?} */ number = parts[1].split('&');
                window.location.href = parts[0] + 'client_id=' + this.authenticationService.currentUser.client_id + '&' + number[1] + '&' + number[2];
                return observer;
            });
        }
        return Observable$1.create((observer) => {
            return observer;
        });
    }
}
RedirectService.instanceAuthenticationService = '';
RedirectService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
RedirectService.ctorParameters = () => [
    { type: AuthenticationService, },
    { type: CookieService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class HttpService extends ServiceUtil {
    /**
     * @param {?} http
     */
    constructor(http$$1) {
        super();
        this.http = http$$1;
        this.dados = '/dados/';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} url
     * @param {?=} header
     * @param {?=} responseType
     * @return {?}
     */
    get(url, header = new HttpHeaders(), responseType = ResponseContentType.Text) {
        if (responseType != ResponseContentType.Blob) {
            return this.http.get(this.criptografarUrl(url), {
                headers: header,
                observe: 'body',
                responseType: 'json'
            })
                .catch(this.handleError)
                .publishReplay()
                .refCount();
        }
        else {
            return this.http.get(this.criptografarUrl(url), {
                responseType: 'blob',
                observe: 'response'
            })
                .catch(this.handleError)
                .publishReplay()
                .refCount();
        }
    }
    /**
     * @param {?} url
     * @param {?} body
     * @param {?=} header
     * @return {?}
     */
    post(url, body, header = new HttpHeaders()) {
        return this.http.post(this.criptografarUrl(url), body, {
            headers: header,
            observe: 'body',
            responseType: 'json'
        })
            .catch(this.handleError)
            .publishReplay()
            .refCount();
    }
    /**
     * @param {?} url
     * @param {?} body
     * @param {?=} header
     * @return {?}
     */
    put(url, body, header = new HttpHeaders()) {
        return this.http.put(this.criptografarUrl(url), body, {
            headers: header,
            observe: 'body',
            responseType: 'json'
        })
            .catch(this.handleError)
            .publishReplay()
            .refCount();
    }
    /**
     * @param {?} url
     * @param {?=} header
     * @return {?}
     */
    delete(url, header = new HttpHeaders()) {
        return this.http.delete(this.criptografarUrl(url), {
            headers: header,
            observe: 'body',
            responseType: 'json'
        })
            .catch(this.handleError)
            .publishReplay()
            .refCount();
    }
    /**
     * @param {?} url
     * @return {?}
     */
    criptografarUrl(url) {
        let /** @type {?} */ array = url.split('/');
        let /** @type {?} */ urlPart = '';
        let /** @type {?} */ dominio = '';
        let /** @type {?} */ i = 0;
        let /** @type {?} */ protocol = url.split(':');
        if (RedirectService.getInstance().erlangmsUrlMask == "true") {
            if (protocol[0] == 'http' || protocol[0] == 'https') {
                dominio = array[0] + "//" + array[2];
            }
            if (array[1] == "") {
                i = 3;
            }
            else {
                i = 1;
            }
            if (array[3] == 'dados') {
                array.splice(3, 1);
            }
            for (; i < array.length - 1; i++) {
                urlPart += array[i] + "/";
            }
            urlPart += array[i];
            return dominio + "/erl.ms/" + btoa(this.dados + urlPart);
        }
        else {
            if (protocol[0] == 'http' || protocol[0] == 'https') {
                dominio = array[0] + "//" + array[2];
            }
            if (array[1] == "") {
                i = 3;
            }
            else {
                i = 1;
            }
            if (array[3] == 'dados') {
                array.splice(3, 1);
            }
            for (; i < array.length - 1; i++) {
                urlPart += array[i] + "/";
            }
            urlPart += array[i];
            return dominio + this.dados + urlPart;
        }
    }
}
HttpService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
HttpService.ctorParameters = () => [
    { type: HttpClient, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class EventEmitterService {
    /**
     * @param {?} nomeEvento
     * @return {?}
     */
    static get(nomeEvento) {
        if (!this.emitters[nomeEvento]) {
            this.emitters[nomeEvento] = new EventEmitter();
        }
        return this.emitters[nomeEvento];
    }
    /**
     * @param {?} nomeEvento
     * @return {?}
     */
    static contains(nomeEvento) {
        if (!this.emitters[nomeEvento]) {
            return false;
        }
        return true;
    }
    /**
     * @return {?}
     */
    static dereleAll() {
        this.emitters = {};
    }
}
EventEmitterService.emitters = {};
EventEmitterService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
EventEmitterService.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class AuthInterceptor {
    constructor() {
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    intercept(req, next) {
        let /** @type {?} */ copieReq = req.clone();
        let /** @type {?} */ protocol = [''];
        let /** @type {?} */ url = window.location.href;
        let /** @type {?} */ array = url.split('/');
        let /** @type {?} */ dominio;
        let /** @type {?} */ nomeSistema = array[3].split('#');
        let /** @type {?} */ arrayUrl = RedirectService.getInstance().base_url.split('/');
        let /** @type {?} */ urlRedirect = '';
        let /** @type {?} */ arrayTemporario = [];
        if (array.length == 6) {
            dominio = array[5].split('?');
        }
        else {
            dominio = array[4].split('?');
        }
        if (dominio[0] != "" && dominio[0] != "home" && dominio[0] != "index.html") {
            localStorage.setItem("erlangms_actualRoute_" + nomeSistema, dominio[0]);
        }
        if (arrayUrl[3] == 'dados') {
            arrayUrl.splice(3, 1);
            urlRedirect = arrayUrl[0] + "//" + arrayUrl[2];
        }
        else {
            urlRedirect = RedirectService.getInstance().base_url;
        }
        if (arrayUrl.length == 1) {
            arrayTemporario = url.split('/');
            let /** @type {?} */ host = arrayTemporario[2];
            let /** @type {?} */ hostSemPorta = host.split(':');
            urlRedirect = arrayTemporario[0] + '//' + hostSemPorta[0];
        }
        if (RedirectService.getInstance().currentUser.token != '') {
            AuthInterceptor.headers = new HttpHeaders().set('content-type', 'application/json; charset=utf-8')
                .append('Authorization', 'Bearer ' + RedirectService.getInstance().currentUser.token);
            if (copieReq != undefined) {
                if (copieReq.url != undefined) {
                    protocol = copieReq.url.split(':');
                }
            }
            if (protocol[0] == 'http' || protocol[0] == 'https') {
            }
            else if (copieReq != undefined && RedirectService.getInstance().base_url) {
                copieReq.url = urlRedirect + '' + copieReq.url;
            }
        }
        else if (RedirectService.getInstance().base_url) {
            if (copieReq != undefined) {
                if (copieReq.url != undefined) {
                    protocol = copieReq.url.split(':');
                }
            }
            if (protocol[0] == 'http' || protocol[0] == 'https') {
            }
            else if (copieReq != undefined && RedirectService.getInstance().base_url) {
                copieReq.url = urlRedirect + '' + copieReq.url;
            }
        }
        if (arrayTemporario.length > 1) {
            copieReq.url = urlRedirect + '' + copieReq.url;
        }
        if (copieReq != undefined) {
            copieReq.headers = AuthInterceptor.headers;
        }
        return next.handle(copieReq.clone({ url: copieReq.url }));
    }
}
AuthInterceptor.headers = new HttpHeaders().set('content-type', 'application/json; charset=utf-8');
AuthInterceptor.decorators = [
    { type: Injectable },
];
/** @nocollapse */
AuthInterceptor.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class ResourceOwner {
    constructor() {
        this.codigo = 0;
        this.resource_owner = {
            active: true,
            codigo: 0,
            cpf: '',
            email: '',
            id: 0,
            lista_perfil: [],
            lista_permission: [],
            login: '',
            name: '',
            remap_user_id: null,
            subtype: 0,
            type: 0
        };
        this.user = '';
    }
    /**
     * @return {?}
     */
    getClientId() {
        return ResourceOwner.client_id;
    }
    /**
     * @return {?}
     */
    getCodigo() {
        this.codigo = ResourceOwner.localStorage.resource_owner.id;
        return this.codigo;
    }
    /**
     * @return {?}
     */
    getResourceOwner() {
        this.resource_owner = ResourceOwner.localStorage.resource_owner;
        return this.resource_owner;
    }
    /**
     * @return {?}
     */
    getUser() {
        this.user = ResourceOwner.localStorage.resource_owner.name;
        return this.user;
    }
}
ResourceOwner.localStorage = '';
ResourceOwner.client_id = 0;
ResourceOwner.decorators = [
    { type: Injectable },
];
/** @nocollapse */
ResourceOwner.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class AuthenticationService {
    /**
     * @param {?} http
     * @param {?} cookieService
     * @param {?} httpAngular
     */
    constructor(http$$1, cookieService, httpAngular) {
        this.http = http$$1;
        this.cookieService = cookieService;
        this.httpAngular = httpAngular;
        this.time = 0;
        this.client_secret = "";
        this.port_server = '';
        this.base_url = '';
        this.activatedSystem = true;
        this.erlangmsUrlMask = "false";
        this.clientSecret = 'CPD';
        this.textDate = '';
        this.intervalId = null;
        this.urlSistema = '';
        this.partesUrlSistema = '';
        this.protocoloSistema = '';
        this.dominioSistema = '';
        this.protocol = '';
        this.dominio = '';
        this.urlAuthorize = '';
        this._transformaMilissegundos = 1000;
        this._tempoParaRefresh = 500000;
        this._grant_type = 'refresh_token';
        this._errorNotANumber = 'NaN:NaN:NaN';
        this._nomeArquivoBarramento = 'barramento';
        this.currentUser = {
            token: '',
            user: '',
            client_id: '',
            codigo: '',
            timer: '',
            resource_owner: '',
            refresh_token: '',
            client_secret: '',
            default_host: '',
            expires_in: 3600
        };
        this.nomeDoSistema = "";
        this.dadosDaUrl();
        if (localStorage.getItem(this.nomeDoSistema)) {
            EventEmitterService.get('tokenPreenchido').emit(true);
            var /** @type {?} */ stringObjeto = localStorage.getItem(this.nomeDoSistema);
            var /** @type {?} */ variaveisSistema = JSON.parse(stringObjeto);
            this.currentUser.token = variaveisSistema.token;
            this.currentUser.client_id = variaveisSistema.client_id;
            this.currentUser.codigo = variaveisSistema.codigo;
            this.currentUser.user = variaveisSistema.user;
            this.currentUser.timer = variaveisSistema.timer;
            this.currentUser.resource_owner = variaveisSistema.resource_owner;
            this.currentUser.refresh_token = variaveisSistema.resource_owner.refresh_token;
            this.currentUser.expires_in = variaveisSistema.expires_in;
            ResourceOwner.localStorage = variaveisSistema;
            ResourceOwner.client_id = variaveisSistema.client_id;
        }
    }
    /**
     * @return {?}
     */
    dadosDaUrl() {
        this.urlSistema = window.location.href;
        this.partesUrlSistema = this.urlSistema.split('/');
        this.nomeDoSistema = this.partesUrlSistema[3].split('#');
        this.protocoloSistema = this.partesUrlSistema[0];
        this.dominioSistema = this.partesUrlSistema[2];
    }
    /**
     * @return {?}
     */
    getUrl() {
        return this.httpAngular.get(this.protocoloSistema + '//' + this.dominioSistema + '/' + this.nomeDoSistema + '/' + this._nomeArquivoBarramento, {
            observe: 'body',
            responseType: 'json'
        })
            .map((res) => {
            this.dadosDaUrl();
            this.erlangmsUrlMask = res.url_mask;
            if (res.client_secret) {
                this.clientSecret = res.client_secret;
            }
            let /** @type {?} */ array_auth = res.auth_url.split('/');
            this.protocol = array_auth[0];
            this.dominio = array_auth[2];
            this.currentUser.client_id = res.app_id;
            ResourceOwner.client_id = res.app_id;
            if (array_auth[3] == 'dados') {
                array_auth.splice(3, 1);
            }
            this.urlAuthorize = array_auth[3];
            this.urlAuthorize = "/dados/" + this.urlAuthorize;
            let /** @type {?} */ url = this.protocol + '//' + this.dominio + this.urlAuthorize + '?response_type=code&client_id=' + this.currentUser.client_id + '&state=xyz%20&redirect_uri=' + '/' + this.nomeDoSistema + "/index.html/";
            return { url: url };
        });
    }
    /**
     * @param {?} client
     * @return {?}
     */
    getClientCode(client) {
        let /** @type {?} */ count = client.split("#");
        if (count.length > 1) {
            client = count[0];
        }
        return this.http.get(this.base_url + '/auth/client?filter={"name":"' + client + '"}')
            .map((resposta) => {
            this.nomeDoSistema = client;
            let /** @type {?} */ idClient = resposta[0].id;
            this.currentUser.client_id = idClient;
            this.activatedSystem = resposta[0].active;
            let /** @type {?} */ url = this.protocol + '//' + this.dominio + this.urlAuthorize + '?response_type=code&client_id=' + idClient + '&state=xyz%20&redirect_uri=' + '/' + this.nomeDoSistema + "/index.html/";
            return { code: idClient, url: url };
        });
    }
    /**
     * @param {?} url
     * @param {?} client_id
     * @param {?} client_secret
     * @param {?} code
     * @param {?} grant_type
     * @param {?} redirect_uri
     * @return {?}
     */
    redirectUserTokenAccess(url, client_id, client_secret, code, grant_type, redirect_uri) {
        AuthInterceptor.headers = new HttpHeaders().set('content-type', 'application/x-www-form-urlencoded');
        return this.httpAngular.post(url, 'grant_type=' + grant_type + '&client_id=' + client_id + '&client_secret=' + client_secret + '&code=' + code + '&redirect_uri=' + redirect_uri)
            .map((resposta) => {
            this.addValueUser(resposta, true);
            ResourceOwner.localStorage = resposta;
            EventEmitterService.get('registroToken').emit(resposta.access_token);
            this.cookieService.setCookie("token", this.currentUser.token, this.currentUser.expires_in, '/', this.dominioSistema, false);
            this.periodicIncrement(this.currentUser.expires_in);
            this.cookieService.setCookie("dateAccessPage", this.currentUser.timer, this.currentUser.expires_in, '/', this.dominioSistema, false);
            AuthInterceptor.headers = new HttpHeaders().set('content-type', 'application/json; charset=utf-8');
            return true;
        });
    }
    /**
     * @param {?} resp
     * @param {?} emit
     * @return {?}
     */
    addValueUser(resp, emit) {
        let /** @type {?} */ localDateTime = Date.now();
        this.currentUser.timer = localDateTime.toString();
        let /** @type {?} */ login = resp.resource_owner.login;
        let /** @type {?} */ idPessoa = resp.resource_owner.id;
        this.currentUser.codigo = idPessoa;
        this.currentUser.user = login;
        this.currentUser.resource_owner = resp.resource_owner;
        this.currentUser.refresh_token = resp.refresh_token;
        this.currentUser.token = resp.access_token;
        this.currentUser.expires_in = resp.expires_in;
        this.periodicIncrement(this.currentUser.expires_in);
        localStorage.setItem(this.nomeDoSistema, JSON.stringify(this.currentUser));
        if (emit) {
            EventEmitterService.get('tokenPreenchido').emit(true);
        }
    }
    /**
     * @param {?} sessionTime
     * @return {?}
     */
    periodicIncrement(sessionTime) {
        this.cancelPeriodicIncrement();
        if (this.currentUser.timer) {
            let /** @type {?} */ timeAccess = Date.now();
            sessionTime = this.currentUser.expires_in * this._transformaMilissegundos - (timeAccess - Number(this.currentUser.timer));
            sessionTime = sessionTime / this._transformaMilissegundos;
        }
        this.time = sessionTime * this._transformaMilissegundos;
        let /** @type {?} */ dateFormat = sessionTime;
        this.intervalId = setInterval(() => {
            this.textDate = this.formatDate(dateFormat);
            while (this.textDate == this._errorNotANumber) {
                this.textDate = this.formatDate(dateFormat);
            }
            dateFormat = dateFormat - 1;
            if (this.time < this._tempoParaRefresh) {
                if (this.currentUser.refresh_token) {
                    this.currentUser.token = '';
                    clearInterval(this.intervalId);
                    this.refreshSessionTime(this._grant_type)
                        .subscribe((validado) => {
                    }, (error) => {
                        clearInterval(this.intervalId);
                    });
                }
                else {
                    this.logout();
                }
            }
            else if (!this.currentUser.token) {
                this.logout();
            }
            else {
                this.time = this.time - this._transformaMilissegundos;
                return this.time;
            }
        }, this._transformaMilissegundos);
        return Observable$1.create((observer) => {
            return observer;
        });
    }
    ;
    /**
     * @param {?} timer
     * @return {?}
     */
    formatDate(timer) {
        let /** @type {?} */ hours = Math.floor(timer / 3600);
        let /** @type {?} */ minutes = Math.floor((timer % 3600) / 60);
        let /** @type {?} */ seconds = Math.floor(timer % 60);
        hours = minutes < 10 ? "0" + hours : hours;
        minutes = minutes < 10 ? "0" + minutes : minutes;
        seconds = seconds < 10 ? "0" + seconds : seconds;
        return hours + ":" + minutes + ":" + seconds;
    }
    /**
     * @param {?} grant_type
     * @return {?}
     */
    refreshSessionTime(grant_type) {
        AuthInterceptor.headers = new HttpHeaders().set('content-type', 'application/x-www-form-urlencoded')
            .append("Authorization", "Basic " + btoa(this.currentUser.client_id + ":" + this.clientSecret));
        return this.http.post(this.base_url + '/authorize', 'grant_type=' + grant_type + '&refresh_token=' + this.currentUser.refresh_token)
            .map((resposta) => {
            localStorage.removeItem(this.nomeDoSistema);
            this.addValueUser(resposta, false);
            AuthInterceptor.headers = new HttpHeaders().set('content-type', 'application/json; charset=utf-8');
            this.periodicIncrement(this.currentUser.expires_in);
        });
    }
    /**
     * @return {?}
     */
    cancelPeriodicIncrement() {
        if (this.intervalId != null) {
            clearInterval(this.intervalId);
            this.intervalId = null;
            this.time = 0;
        }
        return Observable$1.create((observer) => {
            return observer;
        });
    }
    ;
    /**
     * @return {?}
     */
    logout() {
        let /** @type {?} */ url = window.location.href;
        let /** @type {?} */ array = url.split('/');
        let /** @type {?} */ dominio = array[2].split(':');
        this.getUrl()
            .subscribe((resp) => {
            this.cancelPeriodicIncrement();
            localStorage.removeItem(this.nomeDoSistema);
            this.cookieService.setCookie("token", ' ', this.currentUser.expires_in, '/', dominio[0], false);
            this.cookieService.setCookie("dateAccessPage", ' ', this.currentUser.expires_in, '/', dominio[0], false);
            this.currentUser = {};
            window.location.href = resp.url;
        });
    }
    /**
     * @return {?}
     */
    reset() {
        let /** @type {?} */ url = window.location.href;
        let /** @type {?} */ array = url.split('/');
        let /** @type {?} */ dominio = array[2].split(':');
        this.getUrl()
            .subscribe((resp) => {
            this.cancelPeriodicIncrement();
            localStorage.removeItem(this.nomeDoSistema);
            this.cookieService.setCookie("token", ' ', this.currentUser.expires_in, '/', dominio[0], false);
            this.cookieService.setCookie("dateAccessPage", ' ', this.currentUser.expires_in, '/', dominio[0], false);
            this.currentUser = {};
        });
    }
    /**
     * @return {?}
     */
    findUser() {
        return this.http.post('/resource', '')
            .map((response) => {
            let /** @type {?} */ login = response.resource_owner.login;
            let /** @type {?} */ idPessoa = response.resource_owner.id;
            this.currentUser.resource_owner = response.resource_owner;
            this.currentUser.user = login;
            this.currentUser.codigo = idPessoa;
        });
    }
}
AuthenticationService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
AuthenticationService.ctorParameters = () => [
    { type: HttpService, },
    { type: CookieService, },
    { type: HttpClient, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class NavigationComponent {
    /**
     * @param {?} authenticationService
     */
    constructor(authenticationService) {
        this.authenticationService = authenticationService;
        this.name_user = '';
        this.email_user = '';
        this.name_system = '';
    }
    /**
     * @return {?}
     */
    ngAfterContentInit() {
        let /** @type {?} */ timeAccess = Date.now();
        let /** @type {?} */ total = timeAccess - Number(this.authenticationService.currentUser.timer);
        if (this.authenticationService.currentUser.expires_in != undefined && this.authenticationService.currentUser.timer != "") {
            if (this.authenticationService.currentUser.expires_in != '') {
                if (total > this.authenticationService.currentUser.expires_in * 1000) {
                    this.authenticationService.logout();
                }
            }
        }
    }
    /**
     * @return {?}
     */
    logout() {
        this.authenticationService.logout();
    }
    /**
     * @return {?}
     */
    verificarUsuarioLogado() {
        if (this.authenticationService.currentUser.token != "" && this.authenticationService.currentUser.token != undefined) {
            this.name_user = this.authenticationService.currentUser.resource_owner.name;
            this.email_user = this.authenticationService.currentUser.resource_owner.email;
            this.name_system = this.authenticationService.nomeDoSistema;
            return true;
        }
        else {
            return false;
        }
    }
}
NavigationComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-navigation',
                template: `
    <!-- User Info -->
		<div class="user-info" *ngIf="verificarUsuarioLogado()">
      <div class="image">
        <img src="assets/images/user.jpeg" width="48" height="48" alt="User" />
      </div>
      <div class="backgroud-color-box info-box bg-blue-unb hover-expand-effect">
          <div class="icon">
              <i class="material-icons">access_time</i>
          </div>
          <div class="content">
              <div class="col-white text">TEMPO DE SESSÃO</div>
              <div class="align-center col-white text count-to" data-from="0" data-to="125" data-speed="1000" data-fresh-interval="20">{{this.authenticationService.textDate}}</div>
          </div>
      </div>
			<div class="info-container">
        <div class="name" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">{{ name_user }}</div>
        <div class="email">{{ email_user }}</div>
        <div class="btn-group user-helper-dropdown">
            <i class="material-icons" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">keyboard_arrow_down</i>
            <ul class="dropdown-menu pull-right">
                <li><a href="javascript:void(0);"><i class="material-icons">person</i>Perfil</a></li>
                <li role="seperator" class="divider"></li>
                <li><a href="javascript:void(0);" (click)="logout()"><i class="material-icons">input</i>Sair</a></li>
            </ul>
        </div>
			</div>
		</div>
		<!-- #User Info -->
    `,
                styles: [
                    `
        .backgroud-color-box {
          background-color: #003664;
        }
      `
                ]
            },] },
];
/** @nocollapse */
NavigationComponent.ctorParameters = () => [
    { type: AuthenticationService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class LoggerService {
    /**
     * @param {?} http
     */
    constructor(http$$1) {
        this.http = http$$1;
        this.token = '';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    getTokenLogger() {
        return this.http.post('/authorize?grant_type=client_credentials&client_id=' + localStorage.getItem("client_id") + '&client_secret=CPD', '')
            .map(result => {
            let /** @type {?} */ getAccess = result.json();
            this.token = getAccess['access_token'];
        });
    }
    /**
     * @param {?} type
     * @param {?} content
     * @return {?}
     */
    sendLogger(type, content) {
        return this.http.post('/logger/print/' + type + '?token=' + this.token, content)
            .map(result => {
        });
    }
}
LoggerService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
LoggerService.ctorParameters = () => [
    { type: Http, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class OauthModule {
}
OauthModule.decorators = [
    { type: NgModule, args: [{
                providers: [HttpService, AuthenticationService, RedirectService, LoggerService, CookieService]
            },] },
];
/** @nocollapse */
OauthModule.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class ReponseInterceptor {
    /**
     * @param {?} cookieService
     */
    constructor(cookieService) {
        this.cookieService = cookieService;
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    intercept(req, next) {
        return next.handle(req).retry(3).do((event) => {
            return event;
        }, (error) => {
            console.log(error);
            let /** @type {?} */ url = window.location.href;
            let /** @type {?} */ array = url.split('/');
            let /** @type {?} */ nomeSistema = array[3].split('#');
            if (JSON.stringify(error.error) == '{"error":"access_denied"}') {
                let /** @type {?} */ url = window.location.href;
                let /** @type {?} */ array = url.split('/');
                let /** @type {?} */ dominio = array[2].split(':');
                localStorage.removeItem(nomeSistema);
                this.cookieService.setCookie("token", ' ', 3600, '/', dominio[0], false);
                this.cookieService.setCookie("dateAccessPage", ' ', 3600, '/', dominio[0], false);
                RedirectService.getInstance().logout();
            }
        });
    }
}
ReponseInterceptor.decorators = [
    { type: Injectable },
];
/** @nocollapse */
ReponseInterceptor.ctorParameters = () => [
    { type: CookieService, },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// Public classes.

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Angular library starter
 * Build an Angular library compatible with AoT compilation & Tree shaking like an official package
 * Copyright Roberto Simonetti
 * MIT license
 * https://github.com/robisim74/angular-library-starter
 */
/**
 * Entry point for all public APIs of the package.
 */

// This file only reexports content of the `src` folder. Keep it that way.

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

export { AuthGuard, AuthenticationService, RedirectService, NavigationComponent, LoggerService, CookieService, HttpService, EventEmitterService, OauthModule, AuthInterceptor, ReponseInterceptor, ResourceOwner, ServiceUtil as ɵa };
//# sourceMappingURL=seguranca.js.map
