/**
 * @license angular-library-starter
 * MIT license
 */

import { Component, EventEmitter, Injectable, NgModule } from '@angular/core';
import { Observable as Observable$1 } from 'rxjs/Observable';
import 'rxjs/add/operator/map';
import { __extends } from 'tslib';
import { Http, Response, ResponseContentType } from '@angular/http';
import 'rxjs/Rx';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import 'rxjs/add/operator/do';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var AuthGuard = (function () {
    function AuthGuard() {
    }
    /**
     * @param {?} route
     * @param {?} state
     * @return {?}
     */
    AuthGuard.prototype.canActivate = /**
     * @param {?} route
     * @param {?} state
     * @return {?}
     */
    function (route, state) {
        if (AuthGuard.hasAccess.indexOf(route.data['nome']) != -1) {
            return true;
        }
        else {
            return false;
        }
    };
    AuthGuard.hasAccess = new Array();
    AuthGuard.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    AuthGuard.ctorParameters = function () { return []; };
    return AuthGuard;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var CookieService = (function () {
    function CookieService() {
    }
    /**
     * @param {?} name
     * @return {?}
     */
    CookieService.prototype.getCookie = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        var /** @type {?} */ ca = document.cookie.split(';');
        var /** @type {?} */ caLen = ca.length;
        var /** @type {?} */ cookieName = name + "=";
        var /** @type {?} */ c;
        for (var /** @type {?} */ i = 0; i < caLen; i += 1) {
            c = ca[i].replace(/^\s\+/g, "");
            if (c.indexOf(cookieName) == 0) {
                return c.substring(cookieName.length, c.length);
            }
        }
        return "";
    };
    /**
     * @param {?} name
     * @param {?} value
     * @param {?} expireMilisecounds
     * @param {?} path
     * @param {?} domain
     * @param {?} secure
     * @return {?}
     */
    CookieService.prototype.setCookie = /**
     * @param {?} name
     * @param {?} value
     * @param {?} expireMilisecounds
     * @param {?} path
     * @param {?} domain
     * @param {?} secure
     * @return {?}
     */
    function (name, value, expireMilisecounds, path, domain, secure) {
        var /** @type {?} */ d = new Date();
        d.setTime(d.getTime() + expireMilisecounds);
        var /** @type {?} */ expires = d.toUTCString();
        var /** @type {?} */ cookirFormatado = name + "=" + value + ";" +
            ((path) ? " path=" + path + ";" : "") +
            ((domain) ? " domain=" + domain + "" : "");
        document.cookie = cookirFormatado;
    };
    CookieService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    CookieService.ctorParameters = function () { return []; };
    return CookieService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ServiceUtil = (function () {
    function ServiceUtil() {
    }
    /**
     * @param {?} res
     * @return {?}
     */
    ServiceUtil.prototype.extractData = /**
     * @param {?} res
     * @return {?}
     */
    function (res) {
        var /** @type {?} */ body = res.json();
        return body.data || {};
    };
    /**
     * @param {?} error
     * @return {?}
     */
    ServiceUtil.prototype.handleError = /**
     * @param {?} error
     * @return {?}
     */
    function (error) {
        var /** @type {?} */ errMsg;
        if (error instanceof Response) {
            var /** @type {?} */ body = error.json() || '';
            var /** @type {?} */ err = body.message || JSON.stringify(body);
            errMsg = err;
        }
        else {
            errMsg = error.message ? error.message : error.toString();
        }
        if (errMsg == "{\"isTrusted\":true}") {
            errMsg = "Servidor de Dados Indisponível Temporariamente.";
        }
        else if (errMsg == "{\"error\":\"eunavailable_service\"}") {
            errMsg = "Servidor de Dados Indisponível Temporariamente.";
        }
        else if (errMsg == "{\"error\": \"enoent_service_contract\"}") {
            return new Observable$1();
        }
        else if (errMsg == "{\"error\": \"einvalid_request\"}") {
            errMsg = "Requisição inválida.";
        }
        else if (errMsg == "{\"error\": \"etimeout_service\"}") {
            errMsg = "Servidor de Dados Indisponível Temporariamente.";
        }
        else if (errMsg == "{\"error\": \"access_denied\"}") {
            return new Observable$1();
        }
        else {
            return Observable$1.throw(error);
        }
        return Observable$1.throw(errMsg);
    };
    return ServiceUtil;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var RedirectService = (function () {
    function RedirectService(authenticationService, cookieService) {
        this.authenticationService = authenticationService;
        this.cookieService = cookieService;
        this.localDateTime = 0;
        this.auth_url = '';
        this.result = '';
        this._aplicacaoInativa = 'inativatedApplication';
        this._rotaAtual = 'erlangms_actualRoute_';
        RedirectService.instanceAuthenticationService = this.authenticationService;
    }
    /**
     * @return {?}
     */
    RedirectService.getInstance = /**
     * @return {?}
     */
    function () {
        return RedirectService.instanceAuthenticationService;
    };
    /**
     * @param {?} baseUrl
     * @return {?}
     */
    RedirectService.prototype.startRedirectFromBarramento = /**
     * @param {?} baseUrl
     * @return {?}
     */
    function (baseUrl) {
        var _this = this;
        var /** @type {?} */ urlName = window.location.href.split('/');
        this.authenticationService.base_url = baseUrl;
        return Observable$1.create(function (observer) {
            _this.authenticationService.getUrl()
                .subscribe(function (result) {
                _this.auth_url = result.url;
                if (_this.authenticationService.currentUser.client_id <= 0) {
                    _this.authenticationService.getClientCode(urlName[3])
                        .subscribe(function (res) {
                        if (_this.authenticationService.activatedSystem) {
                            _this.startInitVerifySessionToken()
                                .subscribe(function (resp) {
                                return observer;
                            }, function (error) {
                                console.log(error);
                            });
                        }
                        else {
                            localStorage.removeItem(urlName[3]);
                            localStorage.removeItem(_this._rotaAtual + '' + urlName[3]);
                            var /** @type {?} */ myVal = document.getElementById(_this._aplicacaoInativa);
                            if (myVal != null) {
                                myVal.innerHTML = "\n                                    <h2>Sistema temporariamente indispon\u00EDvel.</h2>\n                                    ";
                            }
                        }
                    }, function (error) {
                        console.log(error);
                    });
                }
                else {
                    _this.startInitVerifySessionToken()
                        .subscribe(function (resp) {
                        return observer;
                    }, function (error) {
                        console.log(error);
                    });
                }
            }, function (error) {
                console.log(error);
            });
        });
    };
    /**
     * @return {?}
     */
    RedirectService.prototype.startInitVerifySessionToken = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.authenticationService.currentUser.token && this.authenticationService.currentUser.timer) {
            var /** @type {?} */ timeAccess = Date.now();
            var /** @type {?} */ total = timeAccess - Number(this.authenticationService.currentUser.timer);
            if (this.authenticationService.currentUser.expires_in != '') {
                if (total > this.authenticationService.currentUser.expires_in * 1000) {
                    this.authenticationService.reset();
                    return Observable$1.create(function (observer) {
                        return observer;
                    });
                }
                else {
                    var /** @type {?} */ urlName = window.location.href.split('/');
                    this.authenticationService.periodicIncrement(this.authenticationService.currentUser.expires_in);
                    return Observable$1.create(function (observer) {
                        return observer;
                    });
                }
            }
        }
        if (this.authenticationService.currentUser.token && this.authenticationService.currentUser.token != "") {
            return Observable$1.create(function (observer) {
                _this.verifyTimeTokenExpired()
                    .subscribe(function (resposta) {
                    return observer;
                });
            });
        }
        var /** @type {?} */ code = window.location.href.split('code=')[1];
        if (code == undefined) {
            if (this.authenticationService.currentUser.token == '') {
                return Observable$1.create(function (observer) {
                    _this.initVerificationRedirect()
                        .subscribe(function (resp) {
                        return observer;
                    });
                });
            }
            else {
                return Observable$1.create(function (observer) {
                    _this.authenticationService.periodicIncrement(_this.authenticationService.currentUser.expires_in)
                        .subscribe(function (resp) {
                        return observer;
                    });
                });
            }
        }
        else if (this.authenticationService.currentUser.token == '' && code != undefined) {
            return Observable$1.create(function (observer) {
                _this.redirectWithCodeUrl(code)
                    .subscribe(function (resp) {
                    return observer;
                });
            });
        }
        return Observable$1.create(function (observer) {
            return observer;
        });
    };
    /**
     * @return {?}
     */
    RedirectService.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    RedirectService.prototype.verifyTimeTokenExpired = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ dateSecoundAccess = Date.now();
        this.localDateTime = Number(this.authenticationService.currentUser.timer);
        var /** @type {?} */ value = dateSecoundAccess - this.localDateTime;
        if (value >= (this.authenticationService.currentUser.expires_in * 1000)) {
            this.authenticationService.logout();
        }
        return Observable$1.create(function (observer) {
            return observer;
        });
    };
    /**
     * @return {?}
     */
    RedirectService.prototype.initVerificationRedirect = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.authenticationService.currentUser.timer && this.authenticationService.currentUser.token != "") {
            return Observable$1.create(function (observer) {
                _this.verifyTimeTokenExpired()
                    .subscribe(function (resp) {
                    return observer;
                });
            });
        }
        else {
            if (this.authenticationService.currentUser.token != '') {
                return Observable$1.create(function (observer) {
                    _this.authenticationService.periodicIncrement(_this.authenticationService.currentUser.expires_in)
                        .subscribe(function (resp) {
                        return observer;
                    });
                });
            }
            else {
                return Observable$1.create(function (observer) {
                    _this.authenticateClient()
                        .subscribe(function (resp) {
                        return observer;
                    });
                });
            }
        }
    };
    /**
     * @param {?} code
     * @return {?}
     */
    RedirectService.prototype.redirectWithCodeUrl = /**
     * @param {?} code
     * @return {?}
     */
    function (code) {
        var _this = this;
        var /** @type {?} */ url_client = window.location.href;
        var /** @type {?} */ array = url_client.split('/');
        var /** @type {?} */ nomeSistema = array[3].split('#');
        var /** @type {?} */ base_auth = this.auth_url.split('?');
        return Observable$1.create(function (observer) {
            _this.authenticationService.redirectUserTokenAccess(base_auth[0], _this.authenticationService.currentUser.client_id, _this.authenticationService.clientSecret, code, 'authorization_code', '/' + nomeSistema[0] + '/index.html/')
                .subscribe(function (resposta) {
                return observer;
            });
        });
    };
    /**
     * @return {?}
     */
    RedirectService.prototype.authenticateClient = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (!this.authenticationService.currentUser.token) {
            this.authenticationService.reset();
            var /** @type {?} */ urlName = window.location.href.split('/');
            return Observable$1.create(function (observer) {
                var /** @type {?} */ parts = _this.auth_url.split('client_id=');
                var /** @type {?} */ number = parts[1].split('&');
                window.location.href = parts[0] + 'client_id=' + _this.authenticationService.currentUser.client_id + '&' + number[1] + '&' + number[2];
                return observer;
            });
        }
        return Observable$1.create(function (observer) {
            return observer;
        });
    };
    RedirectService.instanceAuthenticationService = '';
    RedirectService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    RedirectService.ctorParameters = function () { return [
        { type: AuthenticationService, },
        { type: CookieService, },
    ]; };
    return RedirectService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var HttpService = (function (_super) {
    __extends(HttpService, _super);
    function HttpService(http$$1) {
        var _this = _super.call(this) || this;
        _this.http = http$$1;
        _this.dados = '/dados/';
        return _this;
    }
    /**
     * @return {?}
     */
    HttpService.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} url
     * @param {?=} header
     * @param {?=} responseType
     * @return {?}
     */
    HttpService.prototype.get = /**
     * @param {?} url
     * @param {?=} header
     * @param {?=} responseType
     * @return {?}
     */
    function (url, header, responseType) {
        if (header === void 0) { header = new HttpHeaders(); }
        if (responseType === void 0) { responseType = ResponseContentType.Text; }
        if (responseType != ResponseContentType.Blob) {
            return this.http.get(this.criptografarUrl(url), {
                headers: header,
                observe: 'body',
                responseType: 'json'
            })
                .catch(this.handleError)
                .publishReplay()
                .refCount();
        }
        else {
            return this.http.get(this.criptografarUrl(url), {
                responseType: 'blob',
                observe: 'response'
            })
                .catch(this.handleError)
                .publishReplay()
                .refCount();
        }
    };
    /**
     * @param {?} url
     * @param {?} body
     * @param {?=} header
     * @return {?}
     */
    HttpService.prototype.post = /**
     * @param {?} url
     * @param {?} body
     * @param {?=} header
     * @return {?}
     */
    function (url, body, header) {
        if (header === void 0) { header = new HttpHeaders(); }
        return this.http.post(this.criptografarUrl(url), body, {
            headers: header,
            observe: 'body',
            responseType: 'json'
        })
            .catch(this.handleError)
            .publishReplay()
            .refCount();
    };
    /**
     * @param {?} url
     * @param {?} body
     * @param {?=} header
     * @return {?}
     */
    HttpService.prototype.put = /**
     * @param {?} url
     * @param {?} body
     * @param {?=} header
     * @return {?}
     */
    function (url, body, header) {
        if (header === void 0) { header = new HttpHeaders(); }
        return this.http.put(this.criptografarUrl(url), body, {
            headers: header,
            observe: 'body',
            responseType: 'json'
        })
            .catch(this.handleError)
            .publishReplay()
            .refCount();
    };
    /**
     * @param {?} url
     * @param {?=} header
     * @return {?}
     */
    HttpService.prototype.delete = /**
     * @param {?} url
     * @param {?=} header
     * @return {?}
     */
    function (url, header) {
        if (header === void 0) { header = new HttpHeaders(); }
        return this.http.delete(this.criptografarUrl(url), {
            headers: header,
            observe: 'body',
            responseType: 'json'
        })
            .catch(this.handleError)
            .publishReplay()
            .refCount();
    };
    /**
     * @param {?} url
     * @return {?}
     */
    HttpService.prototype.criptografarUrl = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        var /** @type {?} */ array = url.split('/');
        var /** @type {?} */ urlPart = '';
        var /** @type {?} */ dominio = '';
        var /** @type {?} */ i = 0;
        var /** @type {?} */ protocol = url.split(':');
        if (RedirectService.getInstance().erlangmsUrlMask == "true") {
            if (protocol[0] == 'http' || protocol[0] == 'https') {
                dominio = array[0] + "//" + array[2];
            }
            if (array[1] == "") {
                i = 3;
            }
            else {
                i = 1;
            }
            if (array[3] == 'dados') {
                array.splice(3, 1);
            }
            for (; i < array.length - 1; i++) {
                urlPart += array[i] + "/";
            }
            urlPart += array[i];
            return dominio + "/erl.ms/" + btoa(this.dados + urlPart);
        }
        else {
            if (protocol[0] == 'http' || protocol[0] == 'https') {
                dominio = array[0] + "//" + array[2];
            }
            if (array[1] == "") {
                i = 3;
            }
            else {
                i = 1;
            }
            if (array[3] == 'dados') {
                array.splice(3, 1);
            }
            for (; i < array.length - 1; i++) {
                urlPart += array[i] + "/";
            }
            urlPart += array[i];
            return dominio + this.dados + urlPart;
        }
    };
    HttpService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    HttpService.ctorParameters = function () { return [
        { type: HttpClient, },
    ]; };
    return HttpService;
}(ServiceUtil));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var EventEmitterService = (function () {
    function EventEmitterService() {
    }
    /**
     * @param {?} nomeEvento
     * @return {?}
     */
    EventEmitterService.get = /**
     * @param {?} nomeEvento
     * @return {?}
     */
    function (nomeEvento) {
        if (!this.emitters[nomeEvento]) {
            this.emitters[nomeEvento] = new EventEmitter();
        }
        return this.emitters[nomeEvento];
    };
    /**
     * @param {?} nomeEvento
     * @return {?}
     */
    EventEmitterService.contains = /**
     * @param {?} nomeEvento
     * @return {?}
     */
    function (nomeEvento) {
        if (!this.emitters[nomeEvento]) {
            return false;
        }
        return true;
    };
    /**
     * @return {?}
     */
    EventEmitterService.dereleAll = /**
     * @return {?}
     */
    function () {
        this.emitters = {};
    };
    EventEmitterService.emitters = {};
    EventEmitterService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    EventEmitterService.ctorParameters = function () { return []; };
    return EventEmitterService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var AuthInterceptor = (function () {
    function AuthInterceptor() {
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    AuthInterceptor.prototype.intercept = /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    function (req, next) {
        var /** @type {?} */ copieReq = req.clone();
        var /** @type {?} */ protocol = [''];
        var /** @type {?} */ url = window.location.href;
        var /** @type {?} */ array = url.split('/');
        var /** @type {?} */ dominio;
        var /** @type {?} */ nomeSistema = array[3].split('#');
        var /** @type {?} */ arrayUrl = RedirectService.getInstance().base_url.split('/');
        var /** @type {?} */ urlRedirect = '';
        var /** @type {?} */ arrayTemporario = [];
        if (array.length == 6) {
            dominio = array[5].split('?');
        }
        else {
            dominio = array[4].split('?');
        }
        if (dominio[0] != "" && dominio[0] != "home" && dominio[0] != "index.html") {
            localStorage.setItem("erlangms_actualRoute_" + nomeSistema, dominio[0]);
        }
        if (arrayUrl[3] == 'dados') {
            arrayUrl.splice(3, 1);
            urlRedirect = arrayUrl[0] + "//" + arrayUrl[2];
        }
        else {
            urlRedirect = RedirectService.getInstance().base_url;
        }
        if (arrayUrl.length == 1) {
            arrayTemporario = url.split('/');
            var /** @type {?} */ host = arrayTemporario[2];
            var /** @type {?} */ hostSemPorta = host.split(':');
            urlRedirect = arrayTemporario[0] + '//' + hostSemPorta[0];
        }
        if (RedirectService.getInstance().currentUser.token != '') {
            AuthInterceptor.headers = new HttpHeaders().set('content-type', 'application/json; charset=utf-8')
                .append('Authorization', 'Bearer ' + RedirectService.getInstance().currentUser.token);
            if (copieReq != undefined) {
                if (copieReq.url != undefined) {
                    protocol = copieReq.url.split(':');
                }
            }
            if (protocol[0] == 'http' || protocol[0] == 'https') {
            }
            else if (copieReq != undefined && RedirectService.getInstance().base_url) {
                copieReq.url = urlRedirect + '' + copieReq.url;
            }
        }
        else if (RedirectService.getInstance().base_url) {
            if (copieReq != undefined) {
                if (copieReq.url != undefined) {
                    protocol = copieReq.url.split(':');
                }
            }
            if (protocol[0] == 'http' || protocol[0] == 'https') {
            }
            else if (copieReq != undefined && RedirectService.getInstance().base_url) {
                copieReq.url = urlRedirect + '' + copieReq.url;
            }
        }
        if (arrayTemporario.length > 1) {
            copieReq.url = urlRedirect + '' + copieReq.url;
        }
        if (copieReq != undefined) {
            copieReq.headers = AuthInterceptor.headers;
        }
        return next.handle(copieReq.clone({ url: copieReq.url }));
    };
    AuthInterceptor.headers = new HttpHeaders().set('content-type', 'application/json; charset=utf-8');
    AuthInterceptor.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    AuthInterceptor.ctorParameters = function () { return []; };
    return AuthInterceptor;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ResourceOwner = (function () {
    function ResourceOwner() {
        this.codigo = 0;
        this.resource_owner = {
            active: true,
            codigo: 0,
            cpf: '',
            email: '',
            id: 0,
            lista_perfil: [],
            lista_permission: [],
            login: '',
            name: '',
            remap_user_id: null,
            subtype: 0,
            type: 0
        };
        this.user = '';
    }
    /**
     * @return {?}
     */
    ResourceOwner.prototype.getClientId = /**
     * @return {?}
     */
    function () {
        return ResourceOwner.client_id;
    };
    /**
     * @return {?}
     */
    ResourceOwner.prototype.getCodigo = /**
     * @return {?}
     */
    function () {
        this.codigo = ResourceOwner.localStorage.resource_owner.id;
        return this.codigo;
    };
    /**
     * @return {?}
     */
    ResourceOwner.prototype.getResourceOwner = /**
     * @return {?}
     */
    function () {
        this.resource_owner = ResourceOwner.localStorage.resource_owner;
        return this.resource_owner;
    };
    /**
     * @return {?}
     */
    ResourceOwner.prototype.getUser = /**
     * @return {?}
     */
    function () {
        this.user = ResourceOwner.localStorage.resource_owner.name;
        return this.user;
    };
    ResourceOwner.localStorage = '';
    ResourceOwner.client_id = 0;
    ResourceOwner.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    ResourceOwner.ctorParameters = function () { return []; };
    return ResourceOwner;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var AuthenticationService = (function () {
    function AuthenticationService(http$$1, cookieService, httpAngular) {
        this.http = http$$1;
        this.cookieService = cookieService;
        this.httpAngular = httpAngular;
        this.time = 0;
        this.client_secret = "";
        this.port_server = '';
        this.base_url = '';
        this.activatedSystem = true;
        this.erlangmsUrlMask = "false";
        this.clientSecret = 'CPD';
        this.textDate = '';
        this.intervalId = null;
        this.urlSistema = '';
        this.partesUrlSistema = '';
        this.protocoloSistema = '';
        this.dominioSistema = '';
        this.protocol = '';
        this.dominio = '';
        this.urlAuthorize = '';
        this._transformaMilissegundos = 1000;
        this._tempoParaRefresh = 500000;
        this._grant_type = 'refresh_token';
        this._errorNotANumber = 'NaN:NaN:NaN';
        this._nomeArquivoBarramento = 'barramento';
        this.currentUser = {
            token: '',
            user: '',
            client_id: '',
            codigo: '',
            timer: '',
            resource_owner: '',
            refresh_token: '',
            client_secret: '',
            default_host: '',
            expires_in: 3600
        };
        this.nomeDoSistema = "";
        this.dadosDaUrl();
        if (localStorage.getItem(this.nomeDoSistema)) {
            EventEmitterService.get('tokenPreenchido').emit(true);
            var /** @type {?} */ stringObjeto = localStorage.getItem(this.nomeDoSistema);
            var /** @type {?} */ variaveisSistema = JSON.parse(stringObjeto);
            this.currentUser.token = variaveisSistema.token;
            this.currentUser.client_id = variaveisSistema.client_id;
            this.currentUser.codigo = variaveisSistema.codigo;
            this.currentUser.user = variaveisSistema.user;
            this.currentUser.timer = variaveisSistema.timer;
            this.currentUser.resource_owner = variaveisSistema.resource_owner;
            this.currentUser.refresh_token = variaveisSistema.resource_owner.refresh_token;
            this.currentUser.expires_in = variaveisSistema.expires_in;
            ResourceOwner.localStorage = variaveisSistema;
            ResourceOwner.client_id = variaveisSistema.client_id;
        }
    }
    /**
     * @return {?}
     */
    AuthenticationService.prototype.dadosDaUrl = /**
     * @return {?}
     */
    function () {
        this.urlSistema = window.location.href;
        this.partesUrlSistema = this.urlSistema.split('/');
        this.nomeDoSistema = this.partesUrlSistema[3].split('#');
        this.protocoloSistema = this.partesUrlSistema[0];
        this.dominioSistema = this.partesUrlSistema[2];
    };
    /**
     * @return {?}
     */
    AuthenticationService.prototype.getUrl = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this.httpAngular.get(this.protocoloSistema + '//' + this.dominioSistema + '/' + this.nomeDoSistema + '/' + this._nomeArquivoBarramento, {
            observe: 'body',
            responseType: 'json'
        })
            .map(function (res) {
            _this.dadosDaUrl();
            _this.erlangmsUrlMask = res.url_mask;
            if (res.client_secret) {
                _this.clientSecret = res.client_secret;
            }
            var /** @type {?} */ array_auth = res.auth_url.split('/');
            _this.protocol = array_auth[0];
            _this.dominio = array_auth[2];
            _this.currentUser.client_id = res.app_id;
            ResourceOwner.client_id = res.app_id;
            if (array_auth[3] == 'dados') {
                array_auth.splice(3, 1);
            }
            _this.urlAuthorize = array_auth[3];
            _this.urlAuthorize = "/dados/" + _this.urlAuthorize;
            var /** @type {?} */ url = _this.protocol + '//' + _this.dominio + _this.urlAuthorize + '?response_type=code&client_id=' + _this.currentUser.client_id + '&state=xyz%20&redirect_uri=' + '/' + _this.nomeDoSistema + "/index.html/";
            return { url: url };
        });
    };
    /**
     * @param {?} client
     * @return {?}
     */
    AuthenticationService.prototype.getClientCode = /**
     * @param {?} client
     * @return {?}
     */
    function (client) {
        var _this = this;
        var /** @type {?} */ count = client.split("#");
        if (count.length > 1) {
            client = count[0];
        }
        return this.http.get(this.base_url + '/auth/client?filter={"name":"' + client + '"}')
            .map(function (resposta) {
            _this.nomeDoSistema = client;
            var /** @type {?} */ idClient = resposta[0].id;
            _this.currentUser.client_id = idClient;
            _this.activatedSystem = resposta[0].active;
            var /** @type {?} */ url = _this.protocol + '//' + _this.dominio + _this.urlAuthorize + '?response_type=code&client_id=' + idClient + '&state=xyz%20&redirect_uri=' + '/' + _this.nomeDoSistema + "/index.html/";
            return { code: idClient, url: url };
        });
    };
    /**
     * @param {?} url
     * @param {?} client_id
     * @param {?} client_secret
     * @param {?} code
     * @param {?} grant_type
     * @param {?} redirect_uri
     * @return {?}
     */
    AuthenticationService.prototype.redirectUserTokenAccess = /**
     * @param {?} url
     * @param {?} client_id
     * @param {?} client_secret
     * @param {?} code
     * @param {?} grant_type
     * @param {?} redirect_uri
     * @return {?}
     */
    function (url, client_id, client_secret, code, grant_type, redirect_uri) {
        var _this = this;
        AuthInterceptor.headers = new HttpHeaders().set('content-type', 'application/x-www-form-urlencoded');
        return this.httpAngular.post(url, 'grant_type=' + grant_type + '&client_id=' + client_id + '&client_secret=' + client_secret + '&code=' + code + '&redirect_uri=' + redirect_uri)
            .map(function (resposta) {
            _this.addValueUser(resposta, true);
            ResourceOwner.localStorage = resposta;
            EventEmitterService.get('registroToken').emit(resposta.access_token);
            _this.cookieService.setCookie("token", _this.currentUser.token, _this.currentUser.expires_in, '/', _this.dominioSistema, false);
            _this.periodicIncrement(_this.currentUser.expires_in);
            _this.cookieService.setCookie("dateAccessPage", _this.currentUser.timer, _this.currentUser.expires_in, '/', _this.dominioSistema, false);
            AuthInterceptor.headers = new HttpHeaders().set('content-type', 'application/json; charset=utf-8');
            return true;
        });
    };
    /**
     * @param {?} resp
     * @param {?} emit
     * @return {?}
     */
    AuthenticationService.prototype.addValueUser = /**
     * @param {?} resp
     * @param {?} emit
     * @return {?}
     */
    function (resp, emit) {
        var /** @type {?} */ localDateTime = Date.now();
        this.currentUser.timer = localDateTime.toString();
        var /** @type {?} */ login = resp.resource_owner.login;
        var /** @type {?} */ idPessoa = resp.resource_owner.id;
        this.currentUser.codigo = idPessoa;
        this.currentUser.user = login;
        this.currentUser.resource_owner = resp.resource_owner;
        this.currentUser.refresh_token = resp.refresh_token;
        this.currentUser.token = resp.access_token;
        this.currentUser.expires_in = resp.expires_in;
        this.periodicIncrement(this.currentUser.expires_in);
        localStorage.setItem(this.nomeDoSistema, JSON.stringify(this.currentUser));
        if (emit) {
            EventEmitterService.get('tokenPreenchido').emit(true);
        }
    };
    /**
     * @param {?} sessionTime
     * @return {?}
     */
    AuthenticationService.prototype.periodicIncrement = /**
     * @param {?} sessionTime
     * @return {?}
     */
    function (sessionTime) {
        var _this = this;
        this.cancelPeriodicIncrement();
        if (this.currentUser.timer) {
            var /** @type {?} */ timeAccess = Date.now();
            sessionTime = this.currentUser.expires_in * this._transformaMilissegundos - (timeAccess - Number(this.currentUser.timer));
            sessionTime = sessionTime / this._transformaMilissegundos;
        }
        this.time = sessionTime * this._transformaMilissegundos;
        var /** @type {?} */ dateFormat = sessionTime;
        this.intervalId = setInterval(function () {
            _this.textDate = _this.formatDate(dateFormat);
            while (_this.textDate == _this._errorNotANumber) {
                _this.textDate = _this.formatDate(dateFormat);
            }
            dateFormat = dateFormat - 1;
            if (_this.time < _this._tempoParaRefresh) {
                if (_this.currentUser.refresh_token) {
                    _this.currentUser.token = '';
                    clearInterval(_this.intervalId);
                    _this.refreshSessionTime(_this._grant_type)
                        .subscribe(function (validado) {
                    }, function (error) {
                        clearInterval(_this.intervalId);
                    });
                }
                else {
                    _this.logout();
                }
            }
            else if (!_this.currentUser.token) {
                _this.logout();
            }
            else {
                _this.time = _this.time - _this._transformaMilissegundos;
                return _this.time;
            }
        }, this._transformaMilissegundos);
        return Observable$1.create(function (observer) {
            return observer;
        });
    };
    
    /**
     * @param {?} timer
     * @return {?}
     */
    AuthenticationService.prototype.formatDate = /**
     * @param {?} timer
     * @return {?}
     */
    function (timer) {
        var /** @type {?} */ hours = Math.floor(timer / 3600);
        var /** @type {?} */ minutes = Math.floor((timer % 3600) / 60);
        var /** @type {?} */ seconds = Math.floor(timer % 60);
        hours = minutes < 10 ? "0" + hours : hours;
        minutes = minutes < 10 ? "0" + minutes : minutes;
        seconds = seconds < 10 ? "0" + seconds : seconds;
        return hours + ":" + minutes + ":" + seconds;
    };
    /**
     * @param {?} grant_type
     * @return {?}
     */
    AuthenticationService.prototype.refreshSessionTime = /**
     * @param {?} grant_type
     * @return {?}
     */
    function (grant_type) {
        var _this = this;
        AuthInterceptor.headers = new HttpHeaders().set('content-type', 'application/x-www-form-urlencoded')
            .append("Authorization", "Basic " + btoa(this.currentUser.client_id + ":" + this.clientSecret));
        return this.http.post(this.base_url + '/authorize', 'grant_type=' + grant_type + '&refresh_token=' + this.currentUser.refresh_token)
            .map(function (resposta) {
            localStorage.removeItem(_this.nomeDoSistema);
            _this.addValueUser(resposta, false);
            AuthInterceptor.headers = new HttpHeaders().set('content-type', 'application/json; charset=utf-8');
            _this.periodicIncrement(_this.currentUser.expires_in);
        });
    };
    /**
     * @return {?}
     */
    AuthenticationService.prototype.cancelPeriodicIncrement = /**
     * @return {?}
     */
    function () {
        if (this.intervalId != null) {
            clearInterval(this.intervalId);
            this.intervalId = null;
            this.time = 0;
        }
        return Observable$1.create(function (observer) {
            return observer;
        });
    };
    
    /**
     * @return {?}
     */
    AuthenticationService.prototype.logout = /**
     * @return {?}
     */
    function () {
        var _this = this;
        var /** @type {?} */ url = window.location.href;
        var /** @type {?} */ array = url.split('/');
        var /** @type {?} */ dominio = array[2].split(':');
        this.getUrl()
            .subscribe(function (resp) {
            _this.cancelPeriodicIncrement();
            localStorage.removeItem(_this.nomeDoSistema);
            _this.cookieService.setCookie("token", ' ', _this.currentUser.expires_in, '/', dominio[0], false);
            _this.cookieService.setCookie("dateAccessPage", ' ', _this.currentUser.expires_in, '/', dominio[0], false);
            _this.currentUser = {};
            window.location.href = resp.url;
        });
    };
    /**
     * @return {?}
     */
    AuthenticationService.prototype.reset = /**
     * @return {?}
     */
    function () {
        var _this = this;
        var /** @type {?} */ url = window.location.href;
        var /** @type {?} */ array = url.split('/');
        var /** @type {?} */ dominio = array[2].split(':');
        this.getUrl()
            .subscribe(function (resp) {
            _this.cancelPeriodicIncrement();
            localStorage.removeItem(_this.nomeDoSistema);
            _this.cookieService.setCookie("token", ' ', _this.currentUser.expires_in, '/', dominio[0], false);
            _this.cookieService.setCookie("dateAccessPage", ' ', _this.currentUser.expires_in, '/', dominio[0], false);
            _this.currentUser = {};
        });
    };
    /**
     * @return {?}
     */
    AuthenticationService.prototype.findUser = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this.http.post('/resource', '')
            .map(function (response) {
            var /** @type {?} */ login = response.resource_owner.login;
            var /** @type {?} */ idPessoa = response.resource_owner.id;
            _this.currentUser.resource_owner = response.resource_owner;
            _this.currentUser.user = login;
            _this.currentUser.codigo = idPessoa;
        });
    };
    AuthenticationService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    AuthenticationService.ctorParameters = function () { return [
        { type: HttpService, },
        { type: CookieService, },
        { type: HttpClient, },
    ]; };
    return AuthenticationService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NavigationComponent = (function () {
    function NavigationComponent(authenticationService) {
        this.authenticationService = authenticationService;
        this.name_user = '';
        this.email_user = '';
        this.name_system = '';
    }
    /**
     * @return {?}
     */
    NavigationComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ timeAccess = Date.now();
        var /** @type {?} */ total = timeAccess - Number(this.authenticationService.currentUser.timer);
        if (this.authenticationService.currentUser.expires_in != undefined && this.authenticationService.currentUser.timer != "") {
            if (this.authenticationService.currentUser.expires_in != '') {
                if (total > this.authenticationService.currentUser.expires_in * 1000) {
                    this.authenticationService.logout();
                }
            }
        }
    };
    /**
     * @return {?}
     */
    NavigationComponent.prototype.logout = /**
     * @return {?}
     */
    function () {
        this.authenticationService.logout();
    };
    /**
     * @return {?}
     */
    NavigationComponent.prototype.verificarUsuarioLogado = /**
     * @return {?}
     */
    function () {
        if (this.authenticationService.currentUser.token != "" && this.authenticationService.currentUser.token != undefined) {
            this.name_user = this.authenticationService.currentUser.resource_owner.name;
            this.email_user = this.authenticationService.currentUser.resource_owner.email;
            this.name_system = this.authenticationService.nomeDoSistema;
            return true;
        }
        else {
            return false;
        }
    };
    NavigationComponent.decorators = [
        { type: Component, args: [{
                    selector: 'app-navigation',
                    template: "\n    <!-- User Info -->\n\t\t<div class=\"user-info\" *ngIf=\"verificarUsuarioLogado()\">\n      <div class=\"image\">\n        <img src=\"assets/images/user.jpeg\" width=\"48\" height=\"48\" alt=\"User\" />\n      </div>\n      <div class=\"backgroud-color-box info-box bg-blue-unb hover-expand-effect\">\n          <div class=\"icon\">\n              <i class=\"material-icons\">access_time</i>\n          </div>\n          <div class=\"content\">\n              <div class=\"col-white text\">TEMPO DE SESS\u00C3O</div>\n              <div class=\"align-center col-white text count-to\" data-from=\"0\" data-to=\"125\" data-speed=\"1000\" data-fresh-interval=\"20\">{{this.authenticationService.textDate}}</div>\n          </div>\n      </div>\n\t\t\t<div class=\"info-container\">\n        <div class=\"name\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\">{{ name_user }}</div>\n        <div class=\"email\">{{ email_user }}</div>\n        <div class=\"btn-group user-helper-dropdown\">\n            <i class=\"material-icons\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"true\">keyboard_arrow_down</i>\n            <ul class=\"dropdown-menu pull-right\">\n                <li><a href=\"javascript:void(0);\"><i class=\"material-icons\">person</i>Perfil</a></li>\n                <li role=\"seperator\" class=\"divider\"></li>\n                <li><a href=\"javascript:void(0);\" (click)=\"logout()\"><i class=\"material-icons\">input</i>Sair</a></li>\n            </ul>\n        </div>\n\t\t\t</div>\n\t\t</div>\n\t\t<!-- #User Info -->\n    ",
                    styles: [
                        "\n        .backgroud-color-box {\n          background-color: #003664;\n        }\n      "
                    ]
                },] },
    ];
    /** @nocollapse */
    NavigationComponent.ctorParameters = function () { return [
        { type: AuthenticationService, },
    ]; };
    return NavigationComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var LoggerService = (function () {
    function LoggerService(http$$1) {
        this.http = http$$1;
        this.token = '';
    }
    /**
     * @return {?}
     */
    LoggerService.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    LoggerService.prototype.getTokenLogger = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this.http.post('/authorize?grant_type=client_credentials&client_id=' + localStorage.getItem("client_id") + '&client_secret=CPD', '')
            .map(function (result) {
            var /** @type {?} */ getAccess = result.json();
            _this.token = getAccess['access_token'];
        });
    };
    /**
     * @param {?} type
     * @param {?} content
     * @return {?}
     */
    LoggerService.prototype.sendLogger = /**
     * @param {?} type
     * @param {?} content
     * @return {?}
     */
    function (type, content) {
        return this.http.post('/logger/print/' + type + '?token=' + this.token, content)
            .map(function (result) {
        });
    };
    LoggerService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    LoggerService.ctorParameters = function () { return [
        { type: Http, },
    ]; };
    return LoggerService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var OauthModule = (function () {
    function OauthModule() {
    }
    OauthModule.decorators = [
        { type: NgModule, args: [{
                    providers: [HttpService, AuthenticationService, RedirectService, LoggerService, CookieService]
                },] },
    ];
    /** @nocollapse */
    OauthModule.ctorParameters = function () { return []; };
    return OauthModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReponseInterceptor = (function () {
    function ReponseInterceptor(cookieService) {
        this.cookieService = cookieService;
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    ReponseInterceptor.prototype.intercept = /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    function (req, next) {
        var _this = this;
        return next.handle(req).retry(3).do(function (event) {
            return event;
        }, function (error) {
            console.log(error);
            var /** @type {?} */ url = window.location.href;
            var /** @type {?} */ array = url.split('/');
            var /** @type {?} */ nomeSistema = array[3].split('#');
            if (JSON.stringify(error.error) == '{"error":"access_denied"}') {
                var /** @type {?} */ url_1 = window.location.href;
                var /** @type {?} */ array_1 = url_1.split('/');
                var /** @type {?} */ dominio = array_1[2].split(':');
                localStorage.removeItem(nomeSistema);
                _this.cookieService.setCookie("token", ' ', 3600, '/', dominio[0], false);
                _this.cookieService.setCookie("dateAccessPage", ' ', 3600, '/', dominio[0], false);
                RedirectService.getInstance().logout();
            }
        });
    };
    ReponseInterceptor.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    ReponseInterceptor.ctorParameters = function () { return [
        { type: CookieService, },
    ]; };
    return ReponseInterceptor;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// Public classes.

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Angular library starter
 * Build an Angular library compatible with AoT compilation & Tree shaking like an official package
 * Copyright Roberto Simonetti
 * MIT license
 * https://github.com/robisim74/angular-library-starter
 */
/**
 * Entry point for all public APIs of the package.
 */

// This file only reexports content of the `src` folder. Keep it that way.

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

export { AuthGuard, AuthenticationService, RedirectService, NavigationComponent, LoggerService, CookieService, HttpService, EventEmitterService, OauthModule, AuthInterceptor, ReponseInterceptor, ResourceOwner, ServiceUtil as ɵa };
//# sourceMappingURL=seguranca.js.map
